Signal Degrade Indication in BFD
Liuyan Han
China Mobile
No.32 Xuanwumen west street
100053
Beijing
China
hanliuyan@chinamobile.com
Minxue Wang
China Mobile
No.32 Xuanwumen west street
100053
Beijing
China
wangminxue@chinamobile.com
Fan Yang
Huawei Technologies
Huawei Campus, No. 156 Beiqing Rd.
Beijing
100095
China
shirley.yangfan@huawei.com
8 July 2022
BFD Working Group
To satisfy the requirements of signal degrade indication described in [I-D.yang-mpls-ps-sdi-sr], this document illustrates the extension of BFD protocol to support signal degrade indication.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Background
Signal Degrade (SD) is categorized as one of triggers to bring survivability challenge to networks [RFC4428]. Not like the signal failure caused by failure of links or nodes, Signal Degrade (SD) is normally caused by fiber aging, fiber impairment, fiber pollution, optical module mismatch or WDM transmission error etc.
The detection and transmission of signal degrade is discussed in [I-D.zhl-mpls-tp-sd] and [I-D.yang-mpls-ps-sdi-sr]. When signal degrade is detected, it can be spread via control plane, forwarding plane, or management plane, or combination of any of them.
BFD [RFC5880] and SBFD [RFC7880] are widely used as the failure notification in networks due to the characteristics of simplicity and efficiency. BFD also provides good opportunity to indicate signal degrade by reflecting it in BFD state changes. This document extends the BFD protocol to carry signal degrade indication in networks.

Terminology
SD: Signal Degrade
BER: Bit Error Rate
MIP: Maintenance Entity Group Intermediate Point
PLR: Packet Loss Rate
FEC: Forwarding Error Correction
SLA: Service Level Agreement
BFD: Bidirectional Forwarding Detection
SBFD: Seamless BFD
OAM: Operation, Administration and Maintenance

Signal Degrade Overview

Signal Degrade Definition
In [IEEE 802.3-2018], Bit Error Rate (BER) is defined as the ratio of the number of bits received in error to the total number of bits received. It is one of parameters to indicate quality of physical links. Depending on the Forwarding Error Correction (FEC) capability of PHYs, BER can be classified into pre-FEC BER and post-FEC BER. The pre-FEC BER value acquired from PHY on receiving port indicates the on wire BER value of physical link. This value can also be measured via external test instruments. Generally speaking, BER specifically refers to pre-FEC BER. If FEC capability is unavailable for some legacy PHYs, it is meaningless to differentiate pre-FEC and post-FEC BER values.
Signal degrade can be detected based on the physical bit error statistic on port level, no matter whether the PHY is with or without Forwarding Error Correction. Port level statistic is an intuitive approach to be best understood in the equipment and network systems. In practice, flexible configuration of the watermark to trigger the indication of signal degrade is also preferred.

Signal Degrade vs Packet Loss Rate
In packet switched network, the measurement of physical link is based on the unit of packet, resulting in either no packet loss or a number of packet loss to indicate the status of link. Although PHYs are defined in [IEEE 802.3-2018], vendors may have different implementations to deal with the error bits when equipment detects them. Moreover, bit is a fix unit, but packet has variable length. Several error bits can lead to one packet loss, or multiple packets' loss. There is no uniform approach to calculate pre-FEC BER into PLR. It means there is no parameter directly indicated the status of physical links in packet switched network.

Use BFD to Support Signal Degrade Indication
For the network where BFD is used to provide the fast failure detection, the minimal detection interval e.g. 3.3ms actually leaves a huge gap of data packets between two consecutive BFD packets when the line rate packets are transmitted over high speed Ethernet link. Take an example of 10Gbps link transmitting the packets with length of 192 bytes to calculate, more than twenty thousand packets are transmitted within 3.3ms. Note that the criteria to announce a failure of BFD based on three consecutive BFD packet loss. It may not be accurate to rely on BFD to detect and trigger the protection mechanism if there is signal degrade on the physical link.

Notification Spread in Network
In current packet switched networks, the error bit information like BER is only obtained and processed locally on each node. There is no indication or advertisement of the errors or its indications of physical links. It should be possible to spread this information via control plane, management plane or even data plane to suit for different needs. Especially, if the signal degrade of the link could be transmitted in data plane and aware by any other nodes, local repair or end-to-end path protection could be performed even more efficiently. Previous work proposed in [I-D.rkhd-mpls-tp-sd], [I-D.zhl-mpls-tp-sd] and [I-D.zhang-ccamp-rsvpte-ber-measure] give the examples of protocol extensions to support SD transmission for further network convergence behaviors. With the emerge of telemetry, it is also possible to collect and report this information more frequently to SDN controller to facilitate the network operation and management.

BFD Extension to Indicate Signal Degrade
The Diagnostic code in BFD specifies the local system's reason for the last change in session state. The definition of the Values is specified in Section 4.1 of [RFC5880].
In this document, reserved values from 9 to 31 are requested to IANA to support the signal degrade indication and removal.
(preamble)
       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |Vers |  Diag   |Sta|P|F|C|A|D|M|  Detect Mult  |    Length     |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                       My Discriminator                        |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                      Your Discriminator                       |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                    Desired Min TX Interval                    |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                   Required Min RX Interval                    |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                 Required Min Echo RX Interval                 |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                   Authentication (optional)                   |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

BFD Packet Format

IANA Considerations
The document requires the definition of the new indication and removal of the signal degrade indication in BFD Value code.

Security Considerations
TBD

Normative References

Informative References
[I-D.yang-mpls-ps-sdi-sr]
[RFC4428]
[I-D.zhl-mpls-tp-sd]
[RFC5880]
[RFC7880]
[I-D.rkhd-mpls-tp-sd]
[I-D.zhang-ccamp-rsvpte-ber-measure]